# modified by cpbotha@ieee.org <http://cpbotha.net/> from this posting:
# http://mail.python.org/pipermail/python-list/2000-December/022606.html

import time
import operator

def withLC(a, b):
    return [i - j for i,j in zip(a,b)]

def withMapLambda(a, b):
    return map(lambda i,j: i-j, a, b)

def withMapOp(a, b):
    return map(operator.sub, a, b)

def stopWatch(function, N=100*10000):
    start = time.clock()
    nlist = map(lambda x: 1.0 * x, range(N))
    function(nlist, nlist)
    stend = time.clock()
    return stend-start

print "Using list comprehension:                 %f" % stopWatch(withLC)
print "Using map with lambda:                    %f" % stopWatch(withMapLambda)
print "Using map with operator:                  %f" % stopWatch(withMapOp)

